"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}
exports.capitalize = capitalize;
function hasBeenCreatedBefore(interfaceDeclarations = [], interfaceDeclaration) {
    const newStructure = interfaceDeclaration.getStructure();
    let structureToRetrun;
    interfaceDeclarations.forEach(declaration => {
        const oldStructure = declaration.getStructure();
        if (JSON.stringify(oldStructure.properties) ===
            JSON.stringify(newStructure.properties)) {
            structureToRetrun = oldStructure.name;
        }
    });
    return structureToRetrun;
}
exports.hasBeenCreatedBefore = hasBeenCreatedBefore;
function addOrRemoveInterface(createdInterface, interfaces = []) {
    const oldInterfaceName = hasBeenCreatedBefore(interfaces, createdInterface);
    if (oldInterfaceName) {
        createdInterface.remove();
        return {
            name: oldInterfaceName,
            interfaces,
        };
    }
    return {
        name: createdInterface.getStructure().name,
        interfaces: [...interfaces, createdInterface],
    };
}
exports.addOrRemoveInterface = addOrRemoveInterface;
function buildTypeStringOfArrayTypes(array) {
    const types = array.join(' | ');
    return `Array<${types}>`;
}
exports.buildTypeStringOfArrayTypes = buildTypeStringOfArrayTypes;
function keepUniq(uniqTypes, type) {
    if (!uniqTypes.includes(type)) {
        return [...uniqTypes, type];
    }
    return uniqTypes;
}
exports.keepUniq = keepUniq;
